%define _unpackaged_files_terminate_build 0

%define DATE			20030624
%define multilib_64_archs	x86_64
%define _gnu			%{nil}
%define gcc_target_platform	%{_target_platform}

%ifarch x86_64
%define	_lib			lib64
%endif

Summary:	Various compilers (C, C++, Objective-C, Java, ...)
Name:		gcc
Version:	3.4.4
Release:	3
License:	GPL
Group:		Development/Languages
Source0:	ftp://ftp.gnu.org/pub/gnu/gcc/gcc-%{version}/gcc-%{version}.tar.bz2
Source1:	gcc-3.4.4-unpackaged-files-gd-2
BuildRoot:	%{_tmppath}/%{name}-%{version}-%{release}-root
BuildRequires:	binutils >= 2.14.90.0.4
BuildRequires:	zlib-devel, gettext
# Make sure pthread.h doesn't contain __thread tokens
BuildRequires:	glibc-devel >= 2.2.90-12
Requires:	cpp = %{version}-%{release}
Requires:	binutils >= 2.14.90.0.4
Conflicts:	gdb < 5.1
Requires:	glibc-devel >= 2.2.90-12
Requires:	libgcc >= %{version}-%{release}

%description
The gcc package contains the GNU Compiler Collection version 3.
You'll need this package in order to compile C code.

%files -f %{name}.lang
  %defattr(-,root,root)
  %{_prefix}/bin/cc
  %{_prefix}/bin/c89
  %{_prefix}/bin/c99
  %{_prefix}/bin/gcc
  %{_prefix}/bin/gcov
  %{_prefix}/bin/protoize
  %{_prefix}/bin/unprotoize
  %{_prefix}/bin/%{gcc_target_platform}-gcc
  %{_mandir}/man1/gcc.1*
  %{_mandir}/man1/gcov.1*
  %dir %{_prefix}/lib/gcc
  %dir %{_prefix}/lib/gcc/%{gcc_target_platform}
  %dir %{_prefix}/lib/gcc/%{gcc_target_platform}/%{version}
  %dir %{_prefix}/lib/gcc/%{gcc_target_platform}/%{version}/include
  %{_prefix}/lib/gcc/%{gcc_target_platform}/%{version}/SYSCALLS.c.X
  %{_prefix}/lib/gcc/%{gcc_target_platform}/%{version}/include/stddef.h
  %{_prefix}/lib/gcc/%{gcc_target_platform}/%{version}/include/stdarg.h
  %{_prefix}/lib/gcc/%{gcc_target_platform}/%{version}/include/varargs.h
  %{_prefix}/lib/gcc/%{gcc_target_platform}/%{version}/include/float.h
  %{_prefix}/lib/gcc/%{gcc_target_platform}/%{version}/include/limits.h
  %{_prefix}/lib/gcc/%{gcc_target_platform}/%{version}/include/stdbool.h
  %{_prefix}/lib/gcc/%{gcc_target_platform}/%{version}/include/iso646.h
  %{_prefix}/lib/gcc/%{gcc_target_platform}/%{version}/include/syslimits.h
  %{_prefix}/lib/gcc/%{gcc_target_platform}/%{version}/include/unwind.h
  %{_prefix}/lib/gcc/%{gcc_target_platform}/%{version}/include/emmintrin.h
  %{_prefix}/lib/gcc/%{gcc_target_platform}/%{version}/include/pmmintrin.h
%ifarch %{ix86} x86_64
  %{_prefix}/lib/gcc/%{gcc_target_platform}/%{version}/include/mmintrin.h
  %{_prefix}/lib/gcc/%{gcc_target_platform}/%{version}/include/xmmintrin.h
%endif
%ifarch ia64
  %{_prefix}/lib/gcc/%{gcc_target_platform}/%{version}/include/ia64intrin.h
%endif
  %{_prefix}/lib/gcc/%{gcc_target_platform}/%{version}/include/README
  %{_prefix}/libexec/gcc/%{gcc_target_platform}/%{version}/cc1
  %{_prefix}/libexec/gcc/%{gcc_target_platform}/%{version}/collect2
  %{_prefix}/lib/gcc/%{gcc_target_platform}/%{version}/crt*.o
  %{_prefix}/lib/gcc/%{gcc_target_platform}/%{version}/libgcc.a
  %{_prefix}/lib/gcc/%{gcc_target_platform}/%{version}/libgcc_eh.a
  %{_prefix}/lib/gcc/%{gcc_target_platform}/%{version}/libgcc_s.so
%ifarch %{multilib_64_archs}
  %dir %{_prefix}/lib/gcc/%{gcc_target_platform}/%{version}/32
# %{_prefix}/lib/gcc/%{gcc_target_platform}/%{version}/32/crt*.o
# %{_prefix}/lib/gcc/%{gcc_target_platform}/%{version}/32/libgcc.a
# %{_prefix}/lib/gcc/%{gcc_target_platform}/%{version}/32/libgcc_eh.a
  %{_prefix}/lib/gcc/%{gcc_target_platform}/%{version}/libgcc_s_32.so
%endif
  %{_prefix}/lib/gcc/%{gcc_target_platform}/%{version}/specs
  %doc gcc/README* gcc/*ChangeLog*
  %doc %{_infodir}/gcc*

%package -n libgcc
Summary:	GCC version 3 shared support library
Group:		System Environment/Libraries

%description -n libgcc
This package contains GCC shared support library which is needed
e.g. for exception handling support.

%files -n libgcc
  %defattr(-,root,root)
  /%{_lib}/libgcc_s-%{version}.so.1
  /%{_lib}/libgcc_s.so.1

%package c++
Summary:	C++ support for GCC
Group:		Development/Languages
Requires:	gcc = %{version}-%{release}
Requires:	libstdc++ = %{version}
Requires:	libstdc++-devel = %{version}

%description c++
This package adds C++ support to the GNU Compiler Collection.
It includes support for most of the current C++ specification,
including templates and exception handling.

%files c++
  %defattr(-,root,root)
  %{_prefix}/bin/%{gcc_target_platform}-*++
  %{_prefix}/bin/g++
  %{_prefix}/bin/c++
  ###RWM### %{_prefix}/bin/c++filt
  %{_mandir}/man1/g++.1*
  %dir %{_prefix}/lib/gcc
  %dir %{_prefix}/lib/gcc/%{gcc_target_platform}
  %dir %{_prefix}/lib/gcc/%{gcc_target_platform}/%{version}
  %{_prefix}/libexec/gcc/%{gcc_target_platform}/%{version}/cc1plus
%ifarch %{multilib_64_archs}
  %{_prefix}/lib/gcc/%{gcc_target_platform}/%{version}/32/libstdc++.so
  %{_prefix}/lib/gcc/%{gcc_target_platform}/%{version}/32/libstdc++.a
  %{_prefix}/lib/gcc/%{gcc_target_platform}/%{version}/32/libsupc++.a
  %{_prefix}/lib/gcc/%{gcc_target_platform}/%{version}/32/libsupc++.la
%endif
%ifarch %{multilib_64_archs}
  %{_prefix}/lib/gcc/%{gcc_target_platform}/%{version}/libstdc++.so
# %{_prefix}/lib/gcc/%{gcc_target_platform}/%{version}/libsupc++.a
# %{_prefix}/lib/gcc/%{gcc_target_platform}/%{version}/libsupc++.la
%endif
  %doc gcc/cp/ChangeLog*

%package -n libstdc++
Summary:	GNU Standard C++ Library
Group:		System Environment/Libraries

%description -n libstdc++
The libstdc++ package contains a rewritten standard compliant GCC Standard
C++ Library.

%files -n libstdc++
  %defattr(-,root,root)
  %{_prefix}/%{_lib}/libstdc++.so.6*

%package -n libstdc++-devel
Summary:	Header files and libraries for C++ development
Group:		Development/Libraries
Requires:	libstdc++ = %{version}-%{release}

%description -n libstdc++-devel
This is the GNU implementation of the standard C++ libraries.  This
package includes the header files and libraries needed for C++
development. This includes rewritten implementation of STL.

%files -n libstdc++-devel
  %defattr(-,root,root)
  %doc libstdc++-v3/ChangeLog* libstdc++-v3/README* libstdc++-v3/docs/html/

  %{_prefix}/include/c++
  %{_prefix}/%{_lib}/libstdc++.so
  %{_prefix}/lib/gcc/%{gcc_target_platform}/%{version}/libstdc++.a
  %{_prefix}/lib/gcc/%{gcc_target_platform}/%{version}/libstdc++.la
%ifnarch %{multilib_64_archs}
  %{_prefix}/lib/gcc/%{gcc_target_platform}/%{version}/libstdc++.so
  %{_prefix}/lib/gcc/%{gcc_target_platform}/%{version}/libsupc++.a
  %{_prefix}/lib/gcc/%{gcc_target_platform}/%{version}/libsupc++.la
%endif

%package objc
Summary:	Objective-C support for GCC
Group:		Development/Languages
Requires:	gcc = %{version}-%{release}
Requires:	libobjc = %{version}-%{release}

%description objc
gcc-objc provides Objective-C support for the GCC.
Mainly used on systems running NeXTSTEP, Objective-C is an
object-oriented derivative of the C language.

%files objc
  %defattr(-,root,root)
  %dir %{_prefix}/lib/gcc
  %dir %{_prefix}/lib/gcc/%{gcc_target_platform}
  %dir %{_prefix}/lib/gcc/%{gcc_target_platform}/%{version}
  %dir %{_prefix}/lib/gcc/%{gcc_target_platform}/%{version}/include
  %{_prefix}/lib/gcc/%{gcc_target_platform}/%{version}/include/objc
  %{_prefix}/libexec/gcc/%{gcc_target_platform}/%{version}/cc1obj
# %{_prefix}/lib/gcc/%{gcc_target_platform}/%{version}/libobjc.a
# %{_prefix}/lib/gcc/%{gcc_target_platform}/%{version}/libobjc.la
  %{_prefix}/lib/gcc/%{gcc_target_platform}/%{version}/libobjc.so
%ifarch %{multilib_64_archs}
  %{_prefix}/lib/gcc/%{gcc_target_platform}/%{version}/32/libobjc.a
  %{_prefix}/lib/gcc/%{gcc_target_platform}/%{version}/32/libobjc.so
%endif
  %doc rpm.doc/objc/*
  %doc libobjc/THREADS* libobjc/ChangeLog

%package -n libobjc
Summary:	Objective-C runtime
Group:		System Environment/Libraries

%description -n libobjc
This package contains Objective-C shared library which is needed to run
Objective-C dynamically linked programs.

%files -n libobjc
  %defattr(-,root,root)
  %{_prefix}/%{_lib}/libobjc.so.1*
  %{_prefix}/%{_lib}/libobjc.so

%package -n cpp
Summary:	The C Preprocessor.
Group:		Development/Languages

%description -n cpp
Cpp is the GNU C-Compatible Compiler Preprocessor.
Cpp is a macro processor which is used automatically
by the C compiler to transform your program before actual
compilation. It is called a macro processor because it allows
you to define macros, abbreviations for longer
constructs.

The C preprocessor provides four separate functionalities: the
inclusion of header files (files of declarations that can be
substituted into your program); macro expansion (you can define macros,
and the C preprocessor will replace the macros with their definitions
throughout the program); conditional compilation (using special
preprocessing directives, you can include or exclude parts of the
program according to various conditions); and line control (if you use
a program to combine or rearrange source files into an intermediate
file which is then compiled, you can use line control to inform the
compiler about where each source line originated).

You should install this package if you are a C programmer and you use
macros.

%files -n cpp
  %defattr(-,root,root)
  %doc %{_infodir}/cpp*
  /lib/cpp
  %{_prefix}/bin/cpp
  %{_mandir}/man1/cpp.1*
  %dir %{_prefix}/lib/gcc
  %dir %{_prefix}/lib/gcc/%{gcc_target_platform}
  %dir %{_prefix}/lib/gcc/%{gcc_target_platform}/%{version}

%prep
%setup -q

###RWM### perl -pi -e 's/3\.3\.1/3.3/' gcc/version.c
perl -pi -e 's/"%{version}"/"%{version} \(release\)"/' gcc/version.c
perl -pi -e 's/\((prerelease|experimental|release|Red Hat[^)]*)\)/\(EnGarde Secure Linux %{version}-%{release}\)/' gcc/version.c

# Misdesign in libstdc++
cp -a libstdc++-v3/config/cpu/i{4,3}86/atomicity.h

./contrib/gcc_update --touch

%build

rm -fr obj-%{gcc_target_platform}
mkdir obj-%{gcc_target_platform}
cd obj-%{gcc_target_platform}

CC=gcc
OPT_FLAGS=`echo $RPM_OPT_FLAGS|sed -e 's/-fno-rtti//g' -e 's/-fno-exceptions//g'`
CC="$CC" CFLAGS="$OPT_FLAGS" CXXFLAGS="$OPT_FLAGS" XCFLAGS="$OPT_FLAGS" TCFLAGS="$OPT_FLAGS" \
	../configure --prefix=%{_prefix} --mandir=%{_mandir} --infodir=%{_infodir} \
	--enable-shared --enable-threads=posix --disable-checking \
	--with-system-zlib --enable-__cxa_atexit \
	--disable-multilib \
	--host=%{gcc_target_platform} || :

make %{?_smp_mflags} bootstrap-lean
#make %{?_smp_mflags} bootstrap

# run the tests.
make %{?_smp_mflags} -k check || :
make -C %{gcc_target_platform}/libstdc++-v3/testsuite -k check-abi-verbose || :
echo ====================TESTING=========================
( ../contrib/test_summary || : ) 2>&1 | sed -n '/^cat.*EOF/,/^EOF/{/^cat.*EOF/d;/^EOF/d;/^LAST_UPDATED:/d;p;}'
make -C %{gcc_target_platform}/libstdc++-v3/testsuite -k check-abi || :
echo ====================TESTING END=====================
#cd %{gcc_target_platform}/libstdc++-v3
#./mkcheck 0
#cd ../..

# Make protoize
make -C gcc CC="./xgcc -B ./ -O2" proto

# Make c++filt
###RWM### make -C %{gcc_target_platform}/libiberty CFLAGS="$RPM_OPT_FLAGS" c++filt

# Make generated man pages even if Pod::Man is not new enough
perl -pi -e 's/head3/head2/' ../contrib/texi2pod.pl
for i in ../gcc/doc/*.texi; do
  cp -a $i $i.orig; sed 's/ftable/table/' $i.orig > $i
done
make -C gcc generated-manpages
for i in ../gcc/doc/*.texi; do mv -f $i.orig $i; done

# Copy various doc files here and there
cd ..
mkdir -p rpm.doc/g77 rpm.doc/objc
mkdir -p rpm.doc/boehm-gc rpm.doc/fastjar rpm.doc/libffi rpm.doc/libjava

(cd gcc/objc; for i in README*; do
	cp -p $i ../../rpm.doc/objc/$i.objc
done)
(cd libobjc; for i in README*; do
	cp -p $i ../rpm.doc/objc/$i.libobjc
done)
(cd boehm-gc; for i in ChangeLog*; do
	cp -p $i ../rpm.doc/boehm-gc/$i.gc
done)
(cd libffi; for i in ChangeLog* README* LICENSE; do
	cp -p $i ../rpm.doc/libffi/$i.libffi
done)

%install
  [ "$RPM_BUILD_ROOT" != "/" ] && rm -rf $RPM_BUILD_ROOT

perl -pi -e \
  's~href="l(ibstdc|atest)~href="http://gcc.gnu.org/onlinedocs/libstdc++/l\1~' \
  libstdc++-v3/docs/html/documentation.html
ln -sf documentation.html libstdc++-v3/docs/html/index.html
find libstdc++-v3/docs/html -name CVS | xargs rm -rf

cd obj-%{gcc_target_platform}

if [ ! -f /usr/lib/locale/de_DE/LC_CTYPE ]; then
  export LOCPATH=`pwd`/locale:/usr/lib/locale
fi

TARGET_PLATFORM=%{gcc_target_platform}

# There are some MP bugs in libstdc++ and libjava Makefiles
make -C %{gcc_target_platform}/libstdc++-v3

make prefix=$RPM_BUILD_ROOT%{_prefix} mandir=$RPM_BUILD_ROOT%{_mandir} \
  infodir=$RPM_BUILD_ROOT%{_infodir} install

FULLPATH=$RPM_BUILD_ROOT%{_prefix}/lib/gcc/%{gcc_target_platform}/%{version}

###RWM### cp -a %{gcc_target_platform}/libiberty/c++filt $RPM_BUILD_ROOT%{_prefix}/bin/c++filt
###RWM### chmod 755 $RPM_BUILD_ROOT%{_prefix}/bin/c++filt

# fix some things
ln -sf gcc $RPM_BUILD_ROOT%{_prefix}/bin/cc
mkdir -p $RPM_BUILD_ROOT/lib
ln -sf ..%{_prefix}/bin/cpp $RPM_BUILD_ROOT/lib/cpp
ln -sf g77 $RPM_BUILD_ROOT%{_prefix}/bin/f77
rm -f $RPM_BUILD_ROOT%{_infodir}/dir
gzip -9 $RPM_BUILD_ROOT%{_infodir}/*.info*
###RWM### ln -sf gcc $RPM_BUILD_ROOT%{_prefix}/bin/gnatgcc


if [ -n "$FULLLPATH" ]; then
  mkdir -p $FULLLPATH
else
  FULLLPATH=$FULLPATH
fi

mkdir -p $RPM_BUILD_ROOT/%{_lib}
mv -f $RPM_BUILD_ROOT%{_prefix}/%{_lib}/libgcc_s.so.1 $RPM_BUILD_ROOT/%{_lib}/libgcc_s-%{version}.so.1
chmod 755 $RPM_BUILD_ROOT/%{_lib}/libgcc_s-%{version}.so.1
ln -sf libgcc_s-%{version}.so.1 $RPM_BUILD_ROOT/%{_lib}/libgcc_s.so.1
ln -sf /%{_lib}/libgcc_s.so.1 $FULLPATH/libgcc_s.so
%ifarch %{multilib_64_archs}
ln -sf /lib/libgcc_s.so.1 $FULLPATH/libgcc_s_32.so
%endif

pushd $FULLPATH
if [ "%{_lib}" = "lib" ]; then
ln -sf ../../../libobjc.so.1 libobjc.so
ln -sf ../../../libstdc++.so.5.* libstdc++.so
ln -sf ../../../libg2c.so.0.* libg2c.so
else
ln -sf ../../../../%{_lib}/libobjc.so.1 libobjc.so
ln -sf ../../../../%{_lib}/libstdc++.so.5.* libstdc++.so
ln -sf ../../../../%{_lib}/libg2c.so.0.* libg2c.so
fi
mv -f $RPM_BUILD_ROOT%{_prefix}/%{_lib}/libstdc++.*a $FULLLPATH/
mv -f $RPM_BUILD_ROOT%{_prefix}/%{_lib}/libsupc++.*a .
mv -f $RPM_BUILD_ROOT%{_prefix}/%{_lib}/libg2c.*a .
mv -f $RPM_BUILD_ROOT%{_prefix}/%{_lib}/libfrtbegin.*a .
mv -f $RPM_BUILD_ROOT%{_prefix}/%{_lib}/libobjc.*a .

%ifarch %{multilib_64_archs}
mkdir -p 32
ln -sf ../../../../libobjc.so.1 32/libobjc.so
ln -sf ../`echo ../../../../lib64/libstdc++.so.5.* | sed s~/../lib64/~/~` 32/libstdc++.so
ln -sf ../`echo ../../../../lib64/libg2c.so.0.* | sed s~/../lib64/~/~` 32/libg2c.so
mv -f ./libsupc++.*a 32/
mv -f ./libg2c.*a 32/
mv -f ./libfrtbegin.*a 32/
mv -f ./libobjc.*a 32/
%endif
%ifarch %{multilib_64_archs}
ln -sf ../../../%{multilib_32_arch}-%{_vendor}-%{_target_os}/%{version}/libstdc++.a 32/libstdc++.a
%endif

# Strip debug info from Fortran/ObjC/Java static libraries
strip -g `find . \( -name libg2c.a -o -name libobjc.a -o -name libgcj.a \
		    -o -name lib-org-w3c-dom.a -o -name lib-org-xml-sax.a \
		    -o -name libgcc.a \) -a -type f`
popd
chmod 755 $RPM_BUILD_ROOT%{_prefix}/%{_lib}/libg2c.so.0.*
chmod 755 $RPM_BUILD_ROOT%{_prefix}/%{_lib}/libobjc.so.1.*

for h in `find $FULLPATH/include -name \*.h`; do
  if grep -q 'It has been auto-edited by fixincludes from' $h; then
    rh=`grep -A2 'It has been auto-edited by fixincludes from' $h | tail -1 | sed 's|^.*"\(.*\)".*$|\1|'`
    diff -up $rh $h || :
    rm -f $h
  fi
done

cat > $RPM_BUILD_ROOT%{_prefix}/bin/c89 <<"EOF"
#!/bin/sh
fl="-std=c89"
for opt; do
  case "$opt" in
    -ansi|-std=c89|-std=iso9899:1990) fl="";;
    -std=*) echo "`basename $0` called with non ANSI/ISO C option $opt" >&2
	    exit 1;;
  esac
done
exec %{_prefix}/bin/gcc $fl ${1+"$@"}
EOF
cat > $RPM_BUILD_ROOT%{_prefix}/bin/c99 <<"EOF"
#!/bin/sh
fl="-std=c99"
for opt; do
  case "$opt" in
    -std=c99|-std=iso9899:1999) fl="";;
    -std=*) echo "`basename $0` called with non ISO C99 option $opt" >&2
	    exit 1;;
  esac
done
exec %{_prefix}/bin/gcc $fl ${1+"$@"}
EOF
chmod 755 $RPM_BUILD_ROOT%{_prefix}/bin/c?9

cd ..

  # Remove unpackaged files.
  pushd $RPM_BUILD_ROOT
    cat %{SOURCE1} | xargs rm -v
    rm -fr ./%{_prefix}/%{_lib}/gcc/%{gcc_target_platform}/%{version}/install-tools
  popd

  %find_lang %{name}

%post   -n libgcc -p /sbin/ldconfig
%postun -n libgcc -p /sbin/ldconfig

%post   -n libstdc++ -p /sbin/ldconfig
%postun -n libstdc++ -p /sbin/ldconfig

%post   -n libobjc -p /sbin/ldconfig
%postun -n libobjc -p /sbin/ldconfig

%clean
  [ "$RPM_BUILD_ROOT" != "/" ] && rm -rf $RPM_BUILD_ROOT

%changelog
* Fri Aug 12 2005 Ryan W. Maple <ryan@guardiandigital.com>
- Version 3.4.4, Release 3
  - Remove the localedef for de_DE.

* Tue Jun 28 2005 Ryan W. Maple <ryan@guardiandigital.com>
- Version 3.4.4, Release 1
  - Initial build for EnGarde Secure Linux 3.0.
